// Jeyong Jung (Mar. 2021)
// https://jey-noise.com

const host_version_flag = parseInt(max.version, 16) >= 2068;
const refresh_interval_hibernate = 666;
const refresh_interval_long = 31.25;
const refresh_interval_short = 16.6;
const dists = [ //	           0   1   2   3   4   5   6   7   8
				/* <x_•••> */  49, 27, 14, 12, 2,  49, 36, 23, 47,
				//			   9   10  11  12  13  14  15  16  17  18  19  20  21  22  23  24  25  26  27
				/* <y_•••> */  13, 28, 42, -3, 0,  -3, 11, 14, 11, 27, 30, 27, 41, 44, 43, -1, 10, 21, 32,
				//			   +28
				/* <x_•••> */  48, 31, 14, 12, 2, 55, 41, 27, 53,
				/* <y_•••> */  16, 33, 48, -3, 0, -4, 13, 16, 13, 31, 34, 30, 47, 50, 50, -2, 11, 24, 37,
				//			   +56
				/* <x_•••> */  64, 36, 14, 12, 2, 67, 52, 36, 65,
				/* <y_•••> */  18, 38, 56, -3, 0, -4, 16, 19, 16, 38, 41, 37, 57, 60, 59, -1, 14, 29, 44,
				//			   +84
				/* <x_•••> */  109, 50, 14, 12, 2, 92, 75, 57, 90,
				/* <y_•••> */  24, 49, 71, -3, 0, -4, 19, 22, 19, 45, 48, 44, 67, 70, 70, -1, 17, 35, 53];
var max_res = 32767;
var PDF_size = 3;
var lines_or_bars = 0;
var prev_w = 0;
var prev_h = 0;
var prev_PDF_layout_flag = -1;
var prev_dial_layout_flag = -1;
var prev_misc_layout_flag = -1;
var prev_density = 0;
var prev_spacing = 0;
var prev_lines_or_bars = -1;
var are_you_ready = 0;
var bpatcher_y_offset = 0;
var dim_static_count = 0;
var	tsk_tab_index_alive = 0;
var tsk_change_slider_mode_alive = 0;
var tsk_msg_int_alive = 0;
var tsk_do_your_work, tsk_tab_index, tsk_init_check, tsk_change_slider_mode, tsk_msg_int,
	w, h, anchor, misc_pad_V, misc_pad_H, sw_clipped, sh_clipped, density, setup_height, dial_interval, dial_h, 
	heading_V, misc_height, misc_width, setup_width, spacing, mode_pad_V, mode_pad_H, frame_offset,
	PDF_layout_flag, do_PDF_flags_differ, w_no_clip_flag, dial_layout_flag, misc_layout_flag,
	is_w_changed, is_h_changed, flag0, flag1, do_dial_layout_flags_differ,
	hoi, x1, x2, x3, x4, x5, x6, x7, y0, y1;

outlets = 18;

function gap()
{
	density = max_res / (PDF_size + PDF_size + 1);
	if (!lines_or_bars) {
		if (density >= 3) {
			spacing = Math.floor(density > 5 ? (density - 3) * 0.75 + 2 : density * 0.67);
			switch ((prev_spacing != spacing) + ((prev_lines_or_bars != lines_or_bars) + (prev_density < 3) ? 2 : 0)) {
				case 0:
					break;
				case 1:
					outlet(5, "spacing", spacing);
					break;
				default:
					outlet(5, "spacing", spacing);	
					outlet(5, "setstyle", 1);
			}
			prev_spacing = spacing;	
		} else if ((prev_density >= 3) + (prev_lines_or_bars != lines_or_bars)) {
			outlet(5, "spacing", 0);
			outlet(5, "setstyle", 0);
		}		
	} else {
		spacing = Math.floor(density);
		if ((prev_spacing != spacing) + !prev_lines_or_bars) {
			outlet(5, "spacing", spacing);
		}
		prev_spacing = spacing;
	}
	prev_density = density;
}
gap.local = 1;

function PDF_layout_0()
{
	outlet(0, "script", "sendbox", "comm3", "patching_position", 1, 24);
	outlet(0, "script", "sendbox", "PDF_size", "patching_position", 52, 22);
	outlet(0, "script", "sendbox", "size_frame", "patching_position", 53, 25)
	outlet(0, "script", "sendbox", "comm4", "patching_position", 1, 36);
	outlet(0, "script", "sendbox", "max_size", "patching_position", 53, 36);
	outlet(0, "script", "sendbox", "frame1", "patching_position", 0, 51);
	outlet(0, "script", "sendbox", "PDF", "patching_position", 2, 53);
	outlet(0, "script", "sendbox", "title", "patching_position", 1, 15);
	outlet(0, "script", "sendbox", "multisliderhelp", "patching_position", 37, 15);
	outlet(2, "script", "sendbox", "strip", "patching_position", 0, 0);
	outlet(2, "script", "sendbox", "line0", "patching_position", 0, 0);
	outlet(2, "script", "sendbox", "line1", "patching_position", 4, 2);
	outlet(2, "script", "sendbox", "line2", "patching_position", 6, 5);
	outlet(2, "script", "sendbox", "setup", "patching_position", 0, 27.5);
	outlet(2, "script", "sendbox", "comm0", "patching_position", 0, 0);	
	outlet(2, "script", "sendbox", "comm1", "patching_position", 0, 13);	
}
PDF_layout_0.local = 1;

function PDF_layout_0_perform()
{
	outlet(0, "script", "size", "frame1", w, setup_height - 51);
	outlet(0, "script", "size", "PDF", max_res, setup_height - 55);
	outlet(2, "script", "size", "setup", w, setup_height);
	outlet(1, "patching_rect", 0, 28, w, 11);
	outlet(1, "spacing_x", w * 0.015625);
	if (is_w_changed) {
		outlet(2, "script", "size", "strip", w, 28);
		outlet(2, "script", "size", "line0", w, 5);
		outlet(2, "script", "size", "line1", w - 8, 5);
		outlet(2, "script", "size", "line2", w - 10, 5);
	}
	if (is_w_changed || do_PDF_flags_differ) {
		flag0 = (prev_w > 122) + (w < 123 ? 2 : 0);
		switch (((prev_w == 0) + flag0 > 2)	+ ((prev_w > 182) + 3 - flag0 > 1 ? 2 : 0)) {
			case 1:
				outlet(16, "set", "··f0");
				outlet(8, "set", "··f1");
				outlet(2, "script", "sendbox", "f0", "patching_position", 17, 0);
				outlet(2, "script", "sendbox", "f0_frame", "patching_position", 19, 1);
				outlet(2, "script", "sendbox", "f1", "patching_position", 17, 14);
				outlet(2, "script", "sendbox", "f1_frame", "patching_position", 19, 15);		
				break;
			case 2:
				outlet(16, "set", "folded-f0");
				outlet(8, "set", "folded-f1");
				outlet(2, "script", "sendbox", "f0", "patching_position", 43, 0);
				outlet(2, "script", "sendbox", "f0_frame", "patching_position", 45, 1);
				outlet(2, "script", "sendbox", "f1", "patching_position", 43, 14);
				outlet(2, "script", "sendbox", "f1_frame", "patching_position", 45, 15);
				break;
			default:
		}
	}
}
PDF_layout_0_perform.local = 1;

function PDF_layout_1()
{
	outlet(0, "script", "sendbox", "comm3", "patching_position", 1, 23);
	outlet(0, "script", "sendbox", "PDF_size", "patching_position", 52, 22);
	outlet(0, "script", "sendbox", "size_frame", "patching_position", 53, 25)
	outlet(0, "script", "sendbox", "comm4", "patching_position", 100, 23);
	outlet(0, "script", "sendbox", "max_size", "patching_position", 151, 23);
	outlet(0, "script", "sendbox", "frame1", "patching_position", 0, 39);
	outlet(0, "script", "sendbox", "PDF", "patching_position", 2, 41);
	outlet(0, "script", "sendbox", "title", "patching_position", 1, 15);
	outlet(0, "script", "sendbox", "multisliderhelp", "patching_position", 37, 15);
	outlet(2, "script", "sendbox", "strip", "patching_position", 0, 0);
	outlet(2, "script", "sendbox", "line0", "patching_position", 0, 0);
	outlet(2, "script", "sendbox", "line1", "patching_position", 4, 2);
	outlet(2, "script", "sendbox", "line2", "patching_position", 5, 5);
	outlet(2, "script", "sendbox", "setup", "patching_position", 0, 17);
	outlet(2, "script", "sendbox", "comm0", "patching_position", 0, 1);
	outlet(2, "script", "sendbox", "comm1", "patching_position", 96, 1);
	outlet(2, "script", "sendbox", "f0", "patching_position", 17, 2);
	outlet(2, "script", "sendbox", "f0_frame", "patching_position", 19, 4);
	outlet(2, "script", "sendbox", "f1", "patching_position", 113, 2);
	outlet(2, "script", "sendbox", "f1_frame", "patching_position", 115, 4);
	outlet(16, "set", "··f0");
	outlet(8, "set", "··f1");	
}
PDF_layout_1.local = 1;

function PDF_layout_1_perform()
{
	outlet(0, "script", "size", "frame1", w, setup_height - 39);
	outlet(0, "script", "size", "PDF", max_res, setup_height - 43);
	outlet(2, "script", "size", "setup", w, setup_height);
	outlet(1, "patching_rect", 0, 17, w, 11);
	outlet(1, "spacing_x", w * 0.015625);
	if (is_w_changed) {
		outlet(2, "script", "size", "strip", w, 17);
		outlet(2, "script", "size", "line0", w, 5);
		outlet(2, "script", "size", "line1", w - 8, 5);
		outlet(2, "script", "size", "line2", w - 10, 5);
	}
}
PDF_layout_1_perform.local = 1;

function PDF_layout_2()
{
	outlet(0, "script", "sendbox", "comm3", "patching_position", 88, 13);
	outlet(0, "script", "sendbox", "PDF_size", "patching_position", 139, 11);
	outlet(0, "script", "sendbox", "size_frame", "patching_position", 140, 14)
	outlet(0, "script", "sendbox", "comm4", "patching_position", 179, 13);
	outlet(0, "script", "sendbox", "max_size", "patching_position", 231, 13);
	outlet(0, "script", "sendbox", "frame1", "patching_position", 0, 28);
	outlet(0, "script", "sendbox", "PDF", "patching_position", 2, 30);
	outlet(0, "script", "sendbox", "title", "patching_position", 1, 15);
	outlet(0, "script", "sendbox", "multisliderhelp", "patching_position", 37, 15);
	outlet(2, "script", "sendbox", "strip", "patching_position", 0, 0);
	outlet(2, "script", "sendbox", "line0", "patching_position", 0, 0);
	outlet(2, "script", "sendbox", "line1", "patching_position", 4, 2);
	outlet(2, "script", "sendbox", "line2", "patching_position", 5, 5);
	outlet(2, "script", "sendbox", "setup", "patching_position", 0, 17);
	outlet(2, "script", "sendbox", "comm0", "patching_position", 0, 1);
	outlet(2, "script", "sendbox", "comm1", "patching_position", 132, 1);	
	outlet(1, "patching_rect", 0, 17, 256, 11);
	outlet(1, "spacing_x", 4);
	outlet(16, "set", "folded-f0");
	outlet(8, "set", "folded-f1");
	outlet(2, "script", "sendbox", "f0", "patching_position", 42, 2);
	outlet(2, "script", "sendbox", "f0_frame", "patching_position", 44, 4);
	outlet(2, "script", "sendbox", "f1", "patching_position", 174, 2);
	outlet(2, "script", "sendbox", "f1_frame", "patching_position", 177, 4);
}
PDF_layout_2.local = 1;

function PDF_layout_2_perform()
{
	outlet(0, "script", "size", "frame1", w, setup_height - 28);
	outlet(0, "script", "size", "PDF", max_res, setup_height - 32);
	outlet(2, "script", "size", "setup", w, setup_height);
	if (is_w_changed) {
		outlet(2, "script", "size", "strip", w, 17);
		outlet(2, "script", "size", "line0", w, 5);
		outlet(2, "script", "size", "line1", w - 8, 5);
		outlet(2, "script", "size", "line2", w - 10, 5);
	}
}
PDF_layout_2_perform.local = 1;

function PDF_layout_3()
{
	outlet(0, "script", "sendbox", "comm3", "patching_position", 260, 2);
	outlet(0, "script", "sendbox", "PDF_size", "patching_position", 311, 0);
	outlet(0, "script", "sendbox", "size_frame", "patching_position", 312, 3)
	outlet(0, "script", "sendbox", "comm4", "patching_position", 349, 2);
	outlet(0, "script", "sendbox", "max_size", "patching_position", 401, 2);
	outlet(0, "script", "sendbox", "frame1", "patching_position", 0, 17);
	outlet(0, "script", "sendbox", "PDF", "patching_position", 2, 19);
	outlet(2, "script", "sendbox", "strip", "patching_position", 0, 0);
	outlet(2, "script", "sendbox", "line0", "patching_position", 0, 0);
	outlet(2, "script", "sendbox", "line1", "patching_position", 4, 2);
	outlet(2, "script", "sendbox", "line2", "patching_position", 5, 5);
	outlet(2, "script", "sendbox", "setup", "patching_position", 0, 17);
	outlet(2, "script", "sendbox", "comm0", "patching_position", 0, 1);
	outlet(2, "script", "sendbox", "comm1", "patching_position", 164, 1);
	outlet(1, "patching_rect", 0, 17, 256, 11);
	outlet(1, "spacing_x", 4);
	outlet(16, "set", "folded-f0");
	outlet(8, "set", "folded-f1");
	outlet(2, "script", "sendbox", "f0", "patching_position", 42, 2);
	outlet(2, "script", "sendbox", "f0_frame", "patching_position", 44, 4);
	outlet(2, "script", "sendbox", "f1", "patching_position", 206, 2);
	outlet(2, "script", "sendbox", "f1_frame", "patching_position", 208, 4);
}
PDF_layout_3.local = 1;

function PDF_layout_3_perform()
{
	outlet(0, "script", "size", "frame1", w, setup_height - 17);
	outlet(0, "script", "size", "PDF", max_res, setup_height - 21);
	outlet(2, "script", "size", "setup", w, setup_height);
	if (is_w_changed) {
		outlet(2, "script", "size", "strip", w, 17);
		outlet(2, "script", "size", "line0", w, 5);
		outlet(2, "script", "size", "line1", w - 8, 5);
		outlet(2, "script", "size", "line2", w - 10, 5);
	}
	if (is_w_changed + do_PDF_flags_differ) {
		outlet(0, "script", "sendbox", "title", "patching_position", w - 84, 4);
		outlet(0, "script", "sendbox", "multisliderhelp", "patching_position", w - 48, 4);
	}
}
PDF_layout_3_perform.local = 1;

function PDF_layout_4()
{
	outlet(0, "script", "sendbox", "comm3", "patching_position", 262, 2);
	outlet(0, "script", "sendbox", "PDF_size", "patching_position", 313, 0);
	outlet(0, "script", "sendbox", "size_frame", "patching_position", 314, 3)
	outlet(0, "script", "sendbox", "comm4", "patching_position", 353, 2);
	outlet(0, "script", "sendbox", "max_size", "patching_position", 405, 2);
	outlet(0, "script", "sendbox", "frame1", "patching_position", 0, 17);
	outlet(0, "script", "sendbox", "PDF", "patching_position", 2, 19);
	outlet(2, "script", "sendbox", "setup", "patching_position", 0, 0);
	outlet(1, "patching_rect", 0, 2, 256, 13);
	outlet(1, "spacing_x", 4);
}
PDF_layout_4.local = 1;

function PDF_layout_4_perform()
{
	outlet(0, "script", "size", "frame1", w, setup_height - 17);
	outlet(0, "script", "size", "PDF", max_res, setup_height - 21);
	outlet(2, "script", "size", "setup", w, setup_height);
	if (is_w_changed) {
		outlet(0, "script", "sendbox", "title", "patching_position", w - 84, 4);
		outlet(0, "script", "sendbox", "multisliderhelp", "patching_position", w - 48, 4);
	}
	if (is_w_changed || do_PDF_flags_differ) {
		flag0 = (prev_w > 789) + (w < 790 ? 2 : 0);
		switch (((prev_w < 760) + flag0 > 2) + (flag0 == 0 ? 2 : 0)) {
			case 1:
				outlet(2, "script", "sendbox", "comm0", "patching_position", 436, 1);
				outlet(2, "script", "sendbox", "comm1", "patching_position", 525, 1);	
				outlet(2, "script", "sendbox", "line0", "patching_position", 438, 0);
				outlet(2, "script", "sendbox", "line1", "patching_position", 442, 2);
				outlet(2, "script", "sendbox", "line2", "patching_position", 443, 5);		
				outlet(2, "script", "sendbox", "strip", "patching_position", 438, 0);
				outlet(2, "script", "size", "strip", 216, 17);
				outlet(2, "script", "size", "line0", 216, 5);
				outlet(2, "script", "size", "line1", 208, 5);
				outlet(2, "script", "size", "line2", 206, 5);	
				outlet(16, "set", "f0");
				outlet(8, "set", "f1                             (folded)");	
				outlet(2, "script", "sendbox", "f0", "patching_position", 446, 2);
				outlet(2, "script", "sendbox", "f0_frame", "patching_position", 448, 4);
				outlet(2, "script", "sendbox", "f1", "patching_position", 535, 2);
				outlet(2, "script", "sendbox", "f1_frame", "patching_position", 537, 4);
				break;
			case 2:
				outlet(2, "script", "sendbox", "comm0", "patching_position", 442, 1);
				outlet(2, "script", "sendbox", "comm1", "patching_position", 574, 1);	
				outlet(2, "script", "sendbox", "line0", "patching_position", 442, 0);
				outlet(2, "script", "sendbox", "line1", "patching_position", 446, 2);
				outlet(2, "script", "sendbox", "line2", "patching_position", 447, 5);		
				outlet(2, "script", "sendbox", "strip", "patching_position", 442, 0);
				outlet(2, "script", "size", "strip", 256, 17);
				outlet(2, "script", "size", "line0", 256, 5);
				outlet(2, "script", "size", "line1", 248, 5);
				outlet(2, "script", "size", "line2", 246, 5);	
				outlet(16, "set", "folded-f0");
				outlet(8, "set", "folded-f1");
				outlet(2, "script", "sendbox", "f0", "patching_position", 484, 2);
				outlet(2, "script", "sendbox", "f0_frame", "patching_position", 486, 4);
				outlet(2, "script", "sendbox", "f1", "patching_position", 616, 2);
				outlet(2, "script", "sendbox", "f1_frame", "patching_position", 618, 4);
				break;
			default:
		}		
	}
}
PDF_layout_4_perform.local = 1;

function dial_style_notext()
{
	outlet(10, 1);
	outlet(11, 7);
	outlet(12, 0);
	outlet(0, "script", "size", "sine^2_spread", 25, dial_h);
	outlet(0, "script", "size", "sine^2_ratio", 25, dial_h);
	outlet(0, "script", "size", "arcsec_spread", 25, dial_h);
	outlet(0, "script", "size", "arcsec_ratio", 25, dial_h);
	outlet(0, "script", "size", "gauss_spread", 25, dial_h);
	outlet(0, "script", "size", "gauss_ratio", 25, dial_h);
	outlet(0, "script", "size", "gauss_shape", 25, dial_h);
	outlet(0, "script", "size", "int/ext", 25, dial_h);
}
dial_style_notext.local = 1;

function dial_style_micro()
{
	outlet(10, 1);
	outlet(11, 7);
	outlet(12, 0);
	outlet(0, "script", "size", "sine^2_spread", 26, dial_h);
	outlet(0, "script", "size", "sine^2_ratio", 26, dial_h);
	outlet(0, "script", "size", "arcsec_spread", 26, dial_h);
	outlet(0, "script", "size", "arcsec_ratio", 26, dial_h);
	outlet(0, "script", "size", "gauss_spread", 26, dial_h);
	outlet(0, "script", "size", "gauss_ratio", 26, dial_h);
	outlet(0, "script", "size", "gauss_shape", 26, dial_h);
	outlet(0, "script", "size", "int/ext", 26, dial_h);
}
dial_style_micro.local = 1;

function dial_style_mini()
{
	outlet(10, 1);
	outlet(11, 8);
	outlet(12, 0);
	outlet(0, "script", "size", "sine^2_spread", 30, dial_h);
	outlet(0, "script", "size", "sine^2_ratio", 30, dial_h);
	outlet(0, "script", "size", "arcsec_spread", 30, dial_h);
	outlet(0, "script", "size", "arcsec_ratio", 30, dial_h);
	outlet(0, "script", "size", "gauss_spread", 30, dial_h);
	outlet(0, "script", "size", "gauss_ratio", 30, dial_h);
	outlet(0, "script", "size", "gauss_shape", 30, dial_h);
	outlet(0, "script", "size", "int/ext", 30, dial_h);
}
dial_style_mini.local = 1;

function dial_style_medium()
{
	outlet(10, 1);
	outlet(11, 9);
	outlet(12, 1);
	outlet(0, "script", "size", "sine^2_spread", 32, dial_h);
	outlet(0, "script", "size", "sine^2_ratio", 32, dial_h);
	outlet(0, "script", "size", "arcsec_spread", 32, dial_h);
	outlet(0, "script", "size", "arcsec_ratio", 32, dial_h);
	outlet(0, "script", "size", "gauss_spread", 32, dial_h);
	outlet(0, "script", "size", "gauss_ratio", 32, dial_h);
	outlet(0, "script", "size", "gauss_shape", 32, dial_h);
	outlet(0, "script", "size", "int/ext", 32, dial_h);
}
dial_style_medium.local = 1;

function dial_style_large()
{
	outlet(10, 0);
	outlet(11, 10);	
	outlet(12, 1);
	outlet(0, "script", "size", "sine^2_spread", 37, dial_h);
	outlet(0, "script", "size", "sine^2_ratio", 37, dial_h);
	outlet(0, "script", "size", "arcsec_spread", 37, dial_h);
	outlet(0, "script", "size", "arcsec_ratio", 37, dial_h);
	outlet(0, "script", "size", "gauss_spread", 37, dial_h);
	outlet(0, "script", "size", "gauss_ratio", 37, dial_h);
	outlet(0, "script", "size", "gauss_shape", 37, dial_h);
	outlet(0, "script", "size", "int/ext", 37, dial_h);
}
dial_style_large.local = 1;

function misc_style_micro()
{
	outlet(14, 8);
	outlet(15, 9);
	outlet(17, 10);
	misc_height = 60;
	misc_width = 94;
	hoi = 0;
	outlet(0, "script", "size", "@err_msg", 45, 14);
	outlet(0, "script", "size", "@ignore_0PDF", 45, 14);
	outlet(0, "script", "size", "@proc_time", 45, 14);
	outlet(0, "script", "size", "sliderstyle", 45, 14);
	outlet(0, "script", "size", "multislidercolor", 67, 14);
	outlet(0, "script", "size", "stripcolor", 67, 14);
	outlet(0, "script", "size", "@active", 25, 27);
	outlet(0, "script", "size", "info", 24, 13);
	outlet(0, "script", "size", "@out0", 24, 13);
	outlet(0, "script", "size", "@out1", 24, 13);
	outlet(0, "script", "size", "@f0_ul", 29, 13);
	outlet(0, "script", "size", "@rectify", 32, 13);
	outlet(0, "script", "size", "f0_frame", 41, 11);
	outlet(0, "script", "size", "f0", 43, 19);
	outlet(0, "script", "size", "f1_frame", 41, 11);
	outlet(0, "script", "size", "f1", 43, 19);
	outlet(0, "script", "size", "fold0_frame", 41, 11);
	outlet(0, "script", "size", "fold0", 43, 19);
	outlet(0, "script", "size", "fold1_frame", 41, 11);
	outlet(0, "script", "size", "fold1", 43, 19);
}
misc_style_micro.local = 1;

function misc_style_mini()
{
	outlet(14, 9);
	outlet(15, 9);
	outlet(17, 11);
	misc_height = 66;
	misc_width = 109;
	hoi = 28;
	outlet(0, "script", "size", "@err_msg", 48, 15);
	outlet(0, "script", "size", "@ignore_0PDF", 61, 15);
	outlet(0, "script", "size", "@proc_time", 48, 15);
	outlet(0, "script", "size", "sliderstyle", 61, 15);
	outlet(0, "script", "size", "multislidercolor", 78, 15);
	outlet(0, "script", "size", "stripcolor", 78, 15);
	outlet(0, "script", "size", "@active", 31, 30);
	outlet(0, "script", "size", "info", 26, 14);
	outlet(0, "script", "size", "@out0", 26, 14);
	outlet(0, "script", "size", "@out1", 26, 14);
	outlet(0, "script", "size", "@f0_ul", 32, 14);
	outlet(0, "script", "size", "@rectify", 34, 14);
	outlet(0, "script", "size", "f0_frame", 50, 11);
	outlet(0, "script", "size", "f0", 52, 19);
	outlet(0, "script", "size", "f1_frame", 50, 11);
	outlet(0, "script", "size", "f1", 52, 19);
	outlet(0, "script", "size", "fold0_frame", 50, 11);
	outlet(0, "script", "size", "fold0", 52, 19);
	outlet(0, "script", "size", "fold1_frame", 50, 11);
	outlet(0, "script", "size", "fold1", 52, 19);
}
misc_style_mini.local = 1;

function misc_style_medium()
{
	outlet(14, 10);
	outlet(15, 11);
	outlet(17, 12);
	misc_height = 76;
	misc_width = 141;
	hoi = 56;
	outlet(0, "script", "size", "@err_msg", 61, 16);
	outlet(0, "script", "size", "@ignore_0PDF", 77, 16);
	outlet(0, "script", "size", "@proc_time", 61, 16);
	outlet(0, "script", "size", "sliderstyle", 77, 16);
	outlet(0, "script", "size", "multislidercolor", 105, 16);
	outlet(0, "script", "size", "stripcolor", 105, 16);
	outlet(0, "script", "size", "@active", 33, 34);
	outlet(0, "script", "size", "info", 34, 15);
	outlet(0, "script", "size", "@out0", 34, 15);
	outlet(0, "script", "size", "@out1", 34, 15);
	outlet(0, "script", "size", "@f0_ul", 37, 15);
	outlet(0, "script", "size", "@rectify", 41, 15);
	outlet(0, "script", "size", "f0_frame", 70, 13);
	outlet(0, "script", "size", "f0", 72, 20);
	outlet(0, "script", "size", "f1_frame", 70, 13);
	outlet(0, "script", "size", "f1", 72, 20);
	outlet(0, "script", "size", "fold0_frame", 70, 13);
	outlet(0, "script", "size", "fold0", 72, 20);
	outlet(0, "script", "size", "fold1_frame", 70, 13);
	outlet(0, "script", "size", "fold1", 72, 20);
}
misc_style_medium.local = 1;

function misc_style_large()
{
	outlet(14, 11);
	outlet(15, 13);
	outlet(17, 14);
	misc_height = 90;
	misc_width = 211;
	hoi = 84;
	outlet(0, "script", "size", "@err_msg", 102, 19);
	outlet(0, "script", "size", "@ignore_0PDF", 102, 19);
	outlet(0, "script", "size", "@proc_time", 102, 19);
	outlet(0, "script", "size", "sliderstyle", 102, 19);
	outlet(0, "script", "size", "multislidercolor", 161, 19);
	outlet(0, "script", "size", "stripcolor", 161, 19);
	outlet(0, "script", "size", "@active", 43, 40);
	outlet(0, "script", "size", "info", 47, 17);
	outlet(0, "script", "size", "@out0", 47, 17);
	outlet(0, "script", "size", "@out1", 47, 17);
	outlet(0, "script", "size", "@f0_ul", 50, 17);
	outlet(0, "script", "size", "@rectify", 55, 17);
	outlet(0, "script", "size", "f0_frame", 115, 17);
	outlet(0, "script", "size", "f0", 117, 23);
	outlet(0, "script", "size", "f1_frame", 115, 17);
	outlet(0, "script", "size", "f1", 117, 23);
	outlet(0, "script", "size", "fold0_frame", 115, 17);
	outlet(0, "script", "size", "fold0", 117, 23);
	outlet(0, "script", "size", "fold1_frame", 115, 17);
	outlet(0, "script", "size", "fold1", 117, 23);
}
misc_style_large.local = 1;

function change_slider_mode(x)
{
	switch ((x != lines_or_bars) + are_you_ready + tsk_change_slider_mode_alive) {
		case 1:
			tsk_change_slider_mode = new Task(change_slider_mode, this, x);
			tsk_change_slider_mode.schedule(refresh_interval_long);
			tsk_change_slider_mode_alive = 4;
			break;
		case 3:
			lines_or_bars = x;
			if (x == 1) {
				outlet(5, "setstyle", 0);
			} else if (x == 2) {
				outlet(5, "setstyle", 1);
			}
			gap();
			prev_lines_or_bars = lines_or_bars;
			break;
		case 5:
			tsk_change_slider_mode.schedule(refresh_interval_long);
			break;
		case 7:
			lines_or_bars = x;
			if (x == 1) {
				outlet(5, "setstyle", 0);
			} else if (x == 2) {
				outlet(5, "setstyle", 1);
			}
			gap();
			prev_lines_or_bars = lines_or_bars;
			if (host_version_flag) {
				arguments.callee.task.freepeer();
			}
			tsk_change_slider_mode_alive = 0;
			break;		
		default:
	}
}

function tab_index(x)
{
	switch ((x != -bpatcher_y_offset) + are_you_ready + tsk_tab_index_alive) {
		case 1:
			tsk_tab_index = new Task(tab_index, this, x);	
			tsk_tab_index.schedule(refresh_interval_long);
			tsk_tab_index_alive = 4;
			break;
		case 3:
			bpatcher_y_offset = -x;
			outlet(9, "offset", 0, setup_height * bpatcher_y_offset);
			break;
		case 5:
			tsk_tab_index.schedule(refresh_interval_long);
			break;
		case 7:
			bpatcher_y_offset = -x;
			outlet(9, "offset", 0, setup_height * bpatcher_y_offset);
			if (host_version_flag) {
				arguments.callee.task.freepeer();
			}
			tsk_tab_index_alive = 0;
			break;
		default:
	}
}

function msg_int(x)
{
	switch ((x != PDF_size) + are_you_ready + tsk_msg_int_alive) {
		case 1:
			tsk_msg_int = new Task(msg_int, this, x);
			tsk_msg_int.schedule(refresh_interval_long);
			tsk_msg_int_alive = 4;
			break;
		case 3:
			if (x > max_res) {
				PDF_size = max_res;
				outlet(7, PDF_size);
				outlet(6, PDF_size);
			} else {
				PDF_size = x;
			}
			gap();
			break;
		case 5:
			tsk_msg_int.schedule(refresh_interval_long);
			break;		
		case 7:
			if (x > max_res) {
				PDF_size = max_res;
				outlet(7, PDF_size);
				outlet(6, PDF_size);
			} else {
				PDF_size = x;
			}
			gap();
			if (host_version_flag) {
				arguments.callee.task.freepeer();
			}
			tsk_msg_int_alive = 0;
			break;
		default:
	}
}

function do_your_work()
{
	switch ((this.patcher.box.rect[2] - this.patcher.box.rect[0] != prev_w
			 || this.patcher.box.rect[3] - this.patcher.box.rect[1] != prev_h)
			+ (dim_static_count < 64 ? 2 : 0)) {
		case 0:
			tsk_do_your_work.schedule(refresh_interval_hibernate);
			break;
		case 2:
			tsk_do_your_work.schedule(refresh_interval_long);
			dim_static_count++;
			break;
		default:
			tsk_do_your_work.schedule(refresh_interval_short);
			
			w = this.patcher.box.rect[2] - this.patcher.box.rect[0];
			h = this.patcher.box.rect[3] - this.patcher.box.rect[1];
			is_w_changed = prev_w != w;
			is_h_changed = prev_h != h;

			if (is_w_changed) {
				max_res = w > 32771 ? 32767 : w - 4;
				outlet(3, "max", max_res);
				outlet(4, "set", max_res);
				outlet(7, max_res);
				if (PDF_size > max_res) {	
					PDF_size = max_res;
					outlet(6, PDF_size);
				}
				gap();		
			}
			PDF_layout_flag = (w < 193) + (w < 256) + (w < 512) + (w < 745);
			do_PDF_flags_differ = prev_PDF_layout_flag != PDF_layout_flag;
			switch (PDF_layout_flag) {
				case 4:
					if (do_PDF_flags_differ) {
						PDF_layout_0();
						heading_V = 12;
					}
					setup_height = h > 97 ? h - 28 : 69;
					PDF_layout_0_perform();
					break;
				case 3:
					if (do_PDF_flags_differ) {
						PDF_layout_1();
						heading_V = 12;
					}
					setup_height = h > 86 ? h - 17 : 69;
					PDF_layout_1_perform();
					break;
				case 2:
					if (do_PDF_flags_differ) {
						PDF_layout_2();
						heading_V = 12;
					}
					setup_height = h > 86 ? h - 17 : 69;
					PDF_layout_2_perform();
					break;
				case 1:
					if (do_PDF_flags_differ) {
						PDF_layout_3();
						heading_V = 12;
					}
					setup_height = h > 86 ? h - 17 : 69;
					PDF_layout_3_perform();
					break;
				case 0:
					if (do_PDF_flags_differ) {
						PDF_layout_4();
						heading_V = 18;
					}
					setup_height = h > 75 ? h : 75;
					PDF_layout_4_perform();
					break;
			}

			setup_width = w - 2;
			outlet(0, "script", "size", "frame2", setup_width, setup_height);
			outlet(0, "script", "size", "frame3", setup_width, setup_height);
			outlet(0, "script", "size", "frame4", setup_width, setup_height);
			if (is_h_changed + do_PDF_flags_differ) {
				frame_offset = setup_height;
				outlet(0, "script", "sendbox", "frame2", "patching_position", 1, frame_offset);
				frame_offset += setup_height;
				outlet(0, "script", "sendbox", "frame3", "patching_position", 1, frame_offset);
				frame_offset += setup_height;
				outlet(0, "script", "sendbox", "frame4", "patching_position", 1, frame_offset);
				outlet(9, "offset", 0, setup_height * bpatcher_y_offset);
			}
			w_no_clip_flag = w > 96;
			sw_clipped = w_no_clip_flag ? w : 96;
			sh_clipped = setup_height - heading_V;
			sh_clipped = sh_clipped > 56 ? sh_clipped : 56;
			dial_layout_flag = ((sw_clipped > 96) + (sh_clipped > 79) == 2)
							   + ((sw_clipped > 111) + (sh_clipped > 83) == 2)
							   + ((sw_clipped > 143) + (sh_clipped > 85) == 2)
							   + ((sw_clipped > 212) + (sh_clipped > 119) == 2);
			do_dial_layout_flags_differ = prev_dial_layout_flag != dial_layout_flag;
			switch (do_dial_layout_flags_differ
					+ (prev_dial_layout_flag != 0 && dial_layout_flag == 0 ? 2 : 0)
					+ (prev_dial_layout_flag <= 0 && dial_layout_flag > 0 ? 4 : 0)) {
				case 3:
					outlet(13, 0);
					break;
				case 5:
					outlet(13, 1);
					break;
				default:
			}
			switch (dial_layout_flag + (do_dial_layout_flags_differ ? 0 : 5)) {
				case 0:
					dial_h = 21;
					dial_style_notext();
				case 1:
					dial_h = 36;
					dial_style_micro();
					break;
				case 2:
					dial_h = 36;
					dial_style_mini();
					break;
				case 3:
					dial_h = 36;
					dial_style_medium();
					break;
				case 4:
					dial_h = 48;
					dial_style_large();
					break;
				default:
			}
			mode_pad_V = 1 + Math.floor((sh_clipped - 60) / 7 + (sh_clipped > 127 ? (sh_clipped - 128) * 0.35 : 0));
			anchor = setup_height + heading_V;
			y0 = anchor + mode_pad_V;
			y1 = anchor + sh_clipped - mode_pad_V - dial_h;
			mode_pad_H = Math.round(sw_clipped < 233 ? (sw_clipped - 94) * 0.17 : 21 + (sw_clipped - 223) * 0.45);
			dial_interval = 20 + Math.round((sw_clipped - mode_pad_H - mode_pad_H - 80) / 6);
			x1 = sw_clipped - dial_interval - mode_pad_H;
			x2 = mode_pad_H + dial_interval;
			outlet(0, "script", "sendbox", "sine^2_spread", "patching_position", mode_pad_H, y0);
			outlet(0, "script", "sendbox", "sine^2_ratio", "patching_position", mode_pad_H + dial_interval, y0);
			outlet(0, "script", "sendbox", "arcsec_spread", "patching_position", x1 - dial_interval, y0);
			outlet(0, "script", "sendbox", "arcsec_ratio", "patching_position", x1, y0);
			outlet(0, "script", "sendbox", "gauss_spread", "patching_position", mode_pad_H, y1);
			outlet(0, "script", "sendbox", "gauss_ratio", "patching_position", x2, y1);
			outlet(0, "script", "sendbox", "gauss_shape", "patching_position", x2 + dial_interval, y1);
			outlet(0, "script", "sendbox", "int/ext", "patching_position", x1, y1);

			misc_layout_flag = dial_layout_flag > 0 ? dial_layout_flag - 1 : 0;
			switch (misc_layout_flag + (prev_misc_layout_flag != misc_layout_flag ? 0 : 4)) {
				case 0:
					misc_style_micro();
					break;
				case 1:
					misc_style_mini();
					break;
				case 2:
					misc_style_medium();
					break;
				case 3:
					misc_style_large();
					break;
				default:
			}
			misc_pad_V = (sh_clipped - misc_height) * 0.5;
			misc_pad_H = (sw_clipped - misc_width) * 0.5;

			anchor += setup_height + misc_pad_V;
			y0 = anchor + dists[hoi + 21];
			x1 = misc_pad_H + dists[hoi + 2];
			x2 = misc_pad_H + dists[hoi + 3];
			x3 = misc_pad_H + dists[hoi + 4];
			x4 = misc_pad_H + dists[hoi + 5];
			x5 = misc_pad_H + dists[hoi + 8];
			x6 = misc_pad_H + dists[hoi + 6];
			x7 = misc_pad_H + dists[hoi + 7];
			outlet(0, "script", "sendbox", "@f0_ul", "patching_position", x3, anchor + dists[hoi + 25]);
			outlet(0, "script", "sendbox", "@rectify", "patching_position", x3, anchor + dists[hoi + 24]);	
			outlet(0, "script", "sendbox", "@out0", "patching_position", x3, anchor + dists[hoi + 26]);
			outlet(0, "script", "sendbox", "@out1", "patching_position", x3, anchor + dists[hoi + 27]);
			outlet(0, "script", "sendbox", "info", "patching_position", x3, anchor + dists[hoi + 23]);		
			outlet(0, "script", "sendbox", "f0", "patching_position", x5, anchor + dists[hoi + 12]);
			outlet(0, "script", "sendbox", "f0_frame", "patching_position", x4, anchor + dists[hoi + 13]);
			outlet(0, "script", "sendbox", "f0_label", "patching_position", x6, anchor + dists[hoi + 14]);
			outlet(0, "script", "sendbox", "f1", "patching_position", x5, anchor + dists[hoi + 15]);
			outlet(0, "script", "sendbox", "f1_frame", "patching_position", x4, anchor + dists[hoi + 16]);
			outlet(0, "script", "sendbox", "f1_label", "patching_position", x6, anchor + dists[hoi + 17]);
			outlet(0, "script", "sendbox", "fold0", "patching_position", x5, anchor + dists[hoi + 18]);
			outlet(0, "script", "sendbox", "fold0_frame", "patching_position", x4, anchor + dists[hoi + 19]);
			outlet(0, "script", "sendbox", "fold0_label", "patching_position", x7, anchor + dists[hoi + 20]);
			outlet(0, "script", "sendbox", "fold1", "patching_position", x5, y0);
			outlet(0, "script", "sendbox", "fold1_label", "patching_position", x7, y0);
			outlet(0, "script", "sendbox", "fold1_frame", "patching_position", x4, anchor + dists[hoi + 22]);

			anchor += setup_height;
			y0 = anchor + dists[hoi + 9];
			x1 = misc_pad_H + dists[hoi];
			x2 = misc_pad_H + dists[hoi + 1];
			outlet(0, "script", "sendbox", "@err_msg", "patching_position", misc_pad_H, anchor);
			outlet(0, "script", "sendbox", "@ignore_0PDF", "patching_position", x1, anchor);
			outlet(0, "script", "sendbox", "@proc_time", "patching_position", misc_pad_H, y0);
			outlet(0, "script", "sendbox", "sliderstyle", "patching_position", x1, y0);
			outlet(0, "script", "sendbox", "@active", "patching_position", misc_pad_H, anchor + dists[hoi + 10]);
			outlet(0, "script", "sendbox", "multislidercolor", "patching_position", x2, anchor + dists[hoi + 10]);
			outlet(0, "script", "sendbox", "stripcolor", "patching_position", x2, anchor + dists[hoi + 11]);
			prev_w = w;
			prev_h = h;
			prev_PDF_layout_flag = PDF_layout_flag;
			prev_dial_layout_flag = dial_layout_flag;
			prev_misc_layout_flag = misc_layout_flag;
			dim_static_count = 0;
	}
}
do_your_work.local = 1;

tsk_do_your_work = new Task(do_your_work, this);

function init_check()
{
	if (outlet(17) && outlet(0) && this.patcher.box) {
		are_you_ready = 2;
		tsk_do_your_work.execute();
		if (host_version_flag) {
			arguments.callee.task.freepeer();
		}
	} else {
		tsk_init_check.schedule(refresh_interval_long);
	}
}
init_check.local = 1;

tsk_init_check = new Task(init_check, this);
tsk_init_check.execute();